﻿



/*-------------------------------------------------------------------
 *  AlertMe                                                         *
 *  Author: Parrot (on the honorbuddy forum)                        *
 *  Version: 1.5                                                   *
 *  Notes: This release has had very limited testing                *
 *  You use this at your own risk.                                  *
 -------------------------------------------------------------------*/



using System.Linq;
using System.Windows.Forms;

namespace AlertMe
{
    using System;
    using Styx.Helpers;
    using Styx.Pathing;
    using System.Threading;
    using System.Diagnostics;
    using Styx.WoWInternals;
    using Styx.WoWInternals.WoWObjects;
    using System.Collections.Generic;
    using System.Linq;
    using System.Linq.Expressions;
    using System.Runtime.InteropServices;
    using System.Xml.Linq;
    using System.Net;
    using Styx.Plugins;
    using Styx.CommonBot;
    using Styx;
    using System.Media;
    using System.Globalization;
    using System.IO;



    public class Alert : HBPlugin
    {
        //Normal Stuff.
        public override string Name { get { return "AlertMe"; } }
        public override string Author { get { return "Parrot"; } }
        public override Version Version { get { return new Version(1, 5); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "Settings"; } }

        private int whispCounter = 0;
        private DateTime shutdownDelay;
        private bool shutdownBool = false;
        private bool newEntry = false;
        

        private static readonly LocalPlayer Me = StyxWoW.Me;
        private DateTime sessionDT;
        private List<WoWObject> playerList = new List<WoWObject>();
        private bool playedPlayerAlert = false;
        private bool init = false;
        public override void OnButtonPress()
        {
            Settings_form sf = new Settings_form();
            sf.ShowDialog();
        }

        private void BotStart(EventArgs args)
        {
            Xml.Load(false);
            resetLocals();            
            sessionDT = DateTime.Now.AddMinutes(Xml.settings.sessionTime);


            Utils.print("Active settings:");
            Utils.print("Whisper alert = " + on_off(Xml.settings.whisperAlert));
            Utils.print("Session shutdown = " + on_off(Xml.settings.sessionShutdown));
            if (Xml.settings.whisperShutdown)
                Utils.print("Whispers before shutdown = " + Xml.settings.whisperLimit.ToString());
            if (Xml.settings.sessionShutdown)
                Utils.print("Session Time = " + Xml.settings.sessionTime.ToString() + " min");
            Utils.print("Player alert = " + on_off(Xml.settings.playerAlert));
            Utils.print("Dont log whispers = " + on_off(Xml.settings.dontLogWhispers));
            Utils.print("--------------------------------");
           

        }

        private string on_off(bool input)
        {
            if (input)
                return "on";
            else
                return "off";
        }


        public override void OnEnable()
        {
            
            if (!init)
            {
                init = true;
                BotEvents.OnBotStarted += BotStart;
                Lua.Events.AttachEvent("CHAT_MSG_WHISPER", handleWhispers);
                Lua.Events.AttachEvent("CHAT_MSG_BN_WHISPER", handleWhispersBN);
            }
            
            
        }

        public override void OnDisable()
        {
           // Utils.print("disposing"); //debug


           // Utils.print("detaching lua"); //debug
            Lua.Events.DetachEvent("CHAT_MSG_WHISPER", handleWhispers);
            Lua.Events.DetachEvent("CHAT_MSG_BN_WHISPER", handleWhispersBN);            

            //Styx.CommonBot.Chat.Whisper -= handleWhispes;
            BotEvents.OnBotStarted -= BotStart;
            init = false;
        }



        private void handleWhispersBN(object sender, LuaEventArgs args)
        {
            whispers(args.Args[0].ToString(), "BN");
        }
        
        private void handleWhispers(object sender, LuaEventArgs args)
        {
            string author = args.Args[1].ToString();
            if (author == Me.Name)
                author = "Me";

            whispers(args.Args[0].ToString(), author);
        
        }

        private void whispers(string msg, string author)
        {
            if (!newEntry)
            {
                whisperLog.newEntry();
                newEntry = true;
            }

            whisperLog.writeLine(string.Format("Received whisper from: {0}", author));
            whisperLog.writeLine(string.Format("Message: {0}", msg));

            if (Xml.settings.dontLogWhispers)
                Utils.print("Received whisper.");
            else
                Utils.print("Received whisper. See the whisper log for details.");

            if (Xml.settings.whisperShutdown)
            {
                ++whispCounter;
                Utils.print(string.Format("Whisper {0}/{1} before shutdown.", whispCounter.ToString(), Xml.settings.whisperLimit.ToString()));
            }

            if (Xml.settings.whisperAlert)
            {
                alertSnd();
            }
        
        }

        public override void Pulse()
        {
            if (Styx.StyxWoW.IsInGame)
            {
                if (Styx.StyxWoW.IsInWorld)
                {
                    run();

                }
            }
            

        }

        private void run()
        {
            if (shutdownBool)
            {
                if (shutdownDelay < DateTime.Now)
                    forceShutdown();
            }
            else
            {
                if (Xml.settings.whisperShutdown
                    && !shutdownBool
                    && whispCounter >= Xml.settings.whisperLimit)
                {
                    alertSnd();
                    Utils.print("Whisper limit exceeded.");
                    shutdown();
                }
                else if (Xml.settings.sessionShutdown)
                {

                    if (sessionDT < DateTime.Now)
                    {
                        alertSnd();
                        resetLocals();
                        Utils.print("Session finished");
                        shutdown();

                    }

                }
            }

            if (Xml.settings.playerAlert)
            {
                if (playersAreNear())
                {
                    if (!playedPlayerAlert)
                    {
                        Utils.print("Player Detected");
                        alertSnd();
                        playedPlayerAlert = true;
                    }
                }
                else
                {
                    if (Xml.settings.playerAlert && playedPlayerAlert)
                    {
                        playedPlayerAlert = false;
                        Utils.print("No players in sight");
                    }
                }
            }
        }

        private void shutdown()
        {
            shutdownBool = true;
            shutdownDelay = DateTime.Now.AddSeconds(15);
            Utils.print("Shutting down in 15 seconds..");
        }

        private void forceShutdown()
        {

            
          
            //shutdowns wow and honorbuddy. should look like a disconnect ingame.
            //The code in this function is orignally written by ZenLulz and has been slightly modified by me. Used with his permission, thanks!

            Lua.DoString("ForceQuit()");

            int intProcessId = Styx.StyxWoW.Memory.Process.Id;
            int intTickCount = Environment.TickCount;
            while (Environment.TickCount - intTickCount < 5000 && Process.GetProcessById(intProcessId) != null)
                Thread.Sleep(200);
            if (Process.GetProcessById(intProcessId) != null)
                Process.GetProcessById(intProcessId).Kill();

            Utils.print("Stopping HonorBuddy...");
            Application.Exit();


        
        }

        private bool playersAreNear()
        {
            ObjectManager.Update();
            playerList = ObjectManager.GetObjectsOfType<WoWObject>(true, true).Where(o =>
                               o != null && o.IsValid && (o.GetType() == typeof(WoWPlayer))).ToList();
            if (playerList.Count > 0)
                return true;
            else
                return false;

        }

        private void alertSnd()
        {
            try
            {
                SoundPlayer sp = new SoundPlayer();
                sp.SoundLocation = Application.StartupPath + @"\Plugins\AlertMe\Sounds\beep.wav";
                sp.Play();
            }
            catch (Exception e) { Utils.print("Error: Could not play audio.\n" + e.Message); }
        }

        private void resetLocals()
        {
            whispCounter = 0;
            shutdownBool = false;
            playedPlayerAlert = false;
        }
    }


}

